#respawn, with added delay to prevent minecraft jumping the gun
execute as @a[scores={death=10..,hp=1..}] at @s run function sprint_racer:game_logic/3/respawn
scoreboard players add @a[scores={death=1..}] death 1

#timer stuff
scoreboard players add @e[name=w] gameTime 1
execute unless entity @a[tag=playing,scores={playerState=2}] run scoreboard players remove @e[name=w,scores={timeRemaining=0..}] timeRemaining 1
function sprint_racer:game_logic/3/end_game_logic

#potion effect nodes
function sprint_racer:game_logic/3/node_effects/node_effects_main
effect give @a minecraft:strength 10 0 true

#node loading stuff, staggered a bit for performance concerns
execute if entity @e[name=w,scores={gameTime=-20..40}] as @a[tag=playing,limit=1] at @s run scoreboard players set @e[limit=1,sort=nearest,tag=node,tag=activator,distance=..200] nodeState 5
scoreboard players add @e[name=w] nodeTimeCycle 1
scoreboard players set @e[name=w,scores={nodeTimeCycle=21..}] nodeTimeCycle 1
execute if entity @e[name=w,scores={nodeTimeCycle=1}] as @e[tag=node,tag=activator,scores={nodeState=1..}] at @s run scoreboard players set @e[tag=node,distance=..100] nodeState 1

#item stuff and score displays
execute if entity @e[name=w,scores={oTimer=0,currentTimeMsec=0,gameTime=160..,timeRemaining=1..}] run function sprint_racer:game_logic/3/once_per_second_stuff
function sprint_racer:items/container_tick
execute if entity @e[name=w,scores={gameTime=200..,timeRemaining=1..}] run function sprint_racer_language:gameplay/battle_subtitle_display_ko

#starting countdown
execute as @e[name=w,scores={gameTime=..240}] run function sprint_racer:game_logic/3/start_countdown

#global timer
execute as @e[name=w,scores={gameTime=160..,timeRemaining=0..}] run function sprint_racer:game_logic/3/global_timer
execute if entity @s[scores={oTimer=1,timeRemaining=0..}] run scoreboard players add @a[tag=playing,tag=!finished] currentTime 1

#actionbar display
execute if entity @e[name=w,scores={gameTime=100..}] run function sprint_racer_language:gameplay/actionbar_display_battle

#track-specific logic
function sprint_racer:levels/_index_levels_battle

#boundary stuff
execute as @e[tag=activeplayer] at @s run function sprint_racer:game_logic/3/boundaries
execute as @e[type=ender_pearl] at @s if block ~ 0 ~ black_wool run kill @s

#keep spectators from flying away
execute if entity @e[name=w,scores={gameTime=100..}] as @a[gamemode=spectator] at @s unless entity @e[tag=activator,distance=..120,scores={nodeState=1..}] run function sprint_racer:spectators_keep_in_bounds

#repeat a few functions in half tick speed mode is enabled
execute if entity @e[name=w,tag=halftick,scores={gameState=3}] run function sprint_racer:game_logic/3/gl3_main_echo

#reset
#scoreboard players remove @a[scores={resetCooldown=1..}] resetCooldown 1
#execute as @a[scores={carrotInput=..999,inputCooldown=..0},nbt={SelectedItem:{tag:{Tags:["reset"]}}}] at @s run function sprint_racer:game_logic/1/reset/player_use_reset

#give reset item (DISABLED IN BATTLE MODE)
#tag @a[tag=hasReset] remove hasReset
#tag @a[gamemode=!creative,tag=playing,nbt={Inventory:[{Slot:8b,id:"minecraft:barrier",tag:{Tags:["reset"]}}]}] add hasReset
#clear @a[gamemode=!creative,tag=!hasReset] barrier
#execute as @a[gamemode=!creative,tag=!hasReset,tag=!noInventory] run function sprint_racer_language:give_barrier