#prevent the AFK system from causing problems while players are held in place
execute if entity @e[name=w,scores={gameTime=..160}] run scoreboard players set @a[tag=playing] afkTime 0

#loading text
execute if entity @e[name=w,scores={gameTime=..-1}] run function sprint_racer_language:gameplay/loading

#kill any old item containers and traps that might be knocking about
execute if entity @e[name=w,scores={gameTime=40}] run kill @e[tag=itemcontainer]
execute if entity @e[name=w,scores={gameTime=40}] run kill @e[tag=trap]
execute if entity @e[name=w,scores={gameTime=40}] run kill @e[type=item,nbt={Item:{tag:{Tags:["item"]}}}]

#keep players from flying about while the track loads
execute if entity @e[name=w,scores={gameTime=-40}] as @a[limit=1,sort=random] at @s run summon armor_stand ~ ~ ~ {NoGravity:1,Invisible:1,Invulnerable:1,Marker:1b,Tags:["RHoldPlayers"]}
execute if entity @e[name=w,scores={gameTime=-40}] run gamemode adventure @a
execute if entity @e[name=w,scores={gameTime=-40}] as @a at @s run spawnpoint @s ~ ~ ~
execute if entity @e[name=w,scores={gameTime=-40..49}] as @a at @s run tp @s @e[limit=1,distance=..100,sort=nearest,tag=RHoldPlayers,type=armor_stand]
execute if entity @e[name=w,scores={gameTime=49}] run kill @e[type=armor_stand,tag=RHoldPlayers]

execute if entity @e[name=w,scores={gameTime=45}] run function sprint_racer:game_logic/3/ai_initialize
execute if entity @e[name=w,scores={gameTime=50}] run scoreboard players set @e[tag=ai] invisibility 1000
execute if entity @e[name=w,scores={gameTime=50}] run team modify player seeFriendlyInvisibles true
execute if entity @e[name=w,scores={gameTime=50}] run function sprint_racer:game_logic/3/find_playerstart_main
execute if entity @e[name=w,scores={gameTime=51}] as @a[tag=!playing] at @s run function sprint_racer:game_logic/3/spectators_setup
execute if entity @e[name=w,scores={gameTime=51..159}] as @e[tag=activeplayer] at @s run tp @s @e[limit=1,scores={nodeState=1..},sort=nearest,tag=node,tag=playerstart,tag=psBattle,distance=..100]
execute if entity @e[name=w,scores={gameTime=52..159}] run effect clear @a blindness
tag @e[name=w,tag=!ignoreCalc,scores={gameTime=100}] add calcStart
execute if entity @e[name=w,scores={gameTime=50}] run gamemode adventure @a[tag=playing,tag=!spectate]
execute if entity @e[name=w,scores={gameTime=50}] as @a[tag=playing] at @s run function sprint_racer:game_logic/3/self_scoreboard_setup
execute if entity @e[name=w,scores={gameTime=50}] as @e[tag=ai] at @s run function sprint_racer:game_logic/3/self_scoreboard_setup_ai
execute if entity @e[name=w,scores={gameTime=140..160}] run scoreboard players set @e[tag=activeplayer] resetCooldown 80
#execute if entity @e[name=w,scores={gameTime=180}] run scoreboard objectives setdisplay sidebar KOs

#show special starting countdown based on the value of "startType"
execute if entity @e[name=w,scores={startType=..0,gameTime=90..}] run function sprint_racer_language:gameplay/start_countdown/battle0
execute if entity @e[name=w,scores={startType=1..,gameTime=90..}] run function sprint_racer_language:gameplay/start_countdown/battle1

#specialized start countdown stuff for individual tracks
execute if entity @e[name=w,scores={gameTime=0..240}] as @e[tag=chosenTrack] run function sprint_racer:levels/_index_levels_battle_start_countdown


#reset speeds and heal players at "GO!"
execute if entity @e[name=w,scores={gameTime=160}] run function sprint_racer:reset_speeds
execute if entity @e[name=w,scores={gameTime=160}] run team modify player seeFriendlyInvisibles false
execute if entity @e[name=w,scores={gameTime=160}] run effect clear @a
execute if entity @e[name=w,scores={gameTime=160}] run effect clear @e[tag=ai]
execute if entity @e[name=w,scores={gameTime=160}] run scoreboard players set @e[tag=ai] invisibility 2
execute if entity @e[name=w,scores={gameTime=160}] run tag @a[tag=noInventory] remove noInventory
execute if entity @e[name=w,scores={gameTime=160}] run tag @a[limit=1] add spdbump