tag @e[tag=vote1] remove vote1
tag @e[tag=vote2] remove vote2
tag @e[tag=vote3] remove vote3

tag @e[tag=voteViable] remove voteViable

#calculating overall "maturity" of players
#this determines what tracks will be offered
scoreboard players set @e[name=w] maturity 0
execute as @a[tag=playing] run scoreboard players operation @e[name=w] maturity += @s maturity
scoreboard players operation @e[name=w] maturity /= @e[name=w,limit=1] playerCountB
scoreboard players set @e[name=w,scores={difficultyRamp=..0}] maturity 100

#maturity ..1 GUARENTEED TUTORIAL, THEN NOVICE ONLY
#maturity 2 NOVICE ONLY
#maturity 3 NOVICE OR INTERMEDIATE
#maturity 4..6 NOVICE TO EXPERT
#maturity 7.. NOVICE TO MASTER

tag @e[name=w] remove forcetutorial
tag @e[name=w,scores={maturity=..1}] add forcetutorial

#mark viable courses for voting, track pool expands to include more difficult tracks the longer everyone plays
execute if entity @e[name=w,scores={maturity=..1}] run tag @e[tag=random,tag=!rtBlacklist,scores={rNumber=2..8}] add voteViable
execute if entity @e[name=w,scores={maturity=2}] run tag @e[tag=random,tag=!rtBlacklist,scores={rNumber=1..8}] add voteViable
execute if entity @e[name=w,scores={maturity=3}] run tag @e[tag=random,tag=!rtBlacklist,scores={rNumber=1..14}] add voteViable
execute if entity @e[name=w,scores={maturity=4..6}] run tag @e[tag=random,tag=!rtBlacklist,scores={rNumber=1..22}] add voteViable
execute if entity @e[name=w,scores={maturity=7..}] run tag @e[tag=random,tag=!rtBlacklist,scores={rNumber=1..23}] add voteViable

function sprint_racer:random/check_for_options_race

####assign slot 1 with a random number
#unless we want to force it to be the tutorial track
tag @e[tag=vote1] remove vote1
execute unless entity @e[name=w,tag=forcetutorial] unless entity @e[tag=vote1] run tag @e[limit=1,sort=random,tag=voteViable,scores={randomCooldown=..0}] add vote1
execute if entity @e[name=w,tag=forcetutorial] run tag @e[limit=1,scores={rNumber=1}] add vote1
execute as @e[tag=nVote1] run scoreboard players operation @s rNumber = @e[tag=vote1,limit=1] rNumber
tag @e[tag=vote1] remove voteViable

function sprint_racer:random/check_for_options_race

####assign slot 2 with a random number
tag @e[limit=1,sort=random,tag=voteViable,tag=!vote1,scores={randomCooldown=..0}] add vote2
execute as @e[tag=nVote2] run scoreboard players operation @s rNumber = @e[tag=vote2,limit=1] rNumber
tag @e[tag=vote2] remove voteViable

function sprint_racer:random/check_for_options_race

####assign slot 3 with a random number
tag @e[limit=1,sort=random,tag=voteViable,tag=!vote1,tag=!vote2,scores={randomCooldown=..0}] add vote3
execute as @e[tag=nVote3] run scoreboard players operation @s rNumber = @e[tag=vote3,limit=1] rNumber
tag @e[tag=vote3] remove voteViable


tag @e[tag=voteViable] remove voteViable
scoreboard players remove @e[scores={randomCooldown=1..}] randomCooldown 1
scoreboard players set @e[tag=vote1] randomCooldown 2
scoreboard players set @e[tag=vote2] randomCooldown 2
scoreboard players set @e[tag=vote3] randomCooldown 2

#error if not all slots were filled...
execute unless entity @e[tag=vote1] run tag @e[tag=random,limit=1,scores={rNumber=50}] add vote1
execute unless entity @e[tag=vote2] run tag @e[tag=random,limit=1,scores={rNumber=50}] add vote2
execute unless entity @e[tag=vote3] run tag @e[tag=random,limit=1,scores={rNumber=50}] add vote3